import {
  Annotation,
  Decorator,
} from '@overflow/commons/core/reflect';

import {
  PropertyKeyType,
  TypeUtil,
} from '@overflow/commons/core/type';

export interface ResourceAnnotationAttributes {
  name: string[];
}

export class ResourceAnnotation implements Annotation {
  public readonly attributes: ResourceAnnotationAttributes;

  public constructor(name: string | ResourceAnnotationAttributes) {

    if (undefined === name) {
      throw new Error(`name attribute must be specified.`);
    }

    if (TypeUtil.isString(name)) {
      this.attributes = {
        name: [<string>name],
      };
    } else {
      this.attributes = <ResourceAnnotationAttributes>name;
    }
  }

  public classDecorator<TFunction extends Function>(target: TFunction): TFunction | void {
    console.log('Resource');
  }

  public propertyDecorator?(target: Object, propertyKey: PropertyKeyType): void {
    console.log('Resource');
  }

  public methodDecorator<T>(target: Object, propertyKey: PropertyKeyType,
                            descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void {
    console.log('Resource');
  }

  public parameterDecorator?(target: Object, propertyKey: PropertyKeyType, parameterIndex: number): void {
    console.log('Resource');
  }
}

export const Resource = Decorator.create(ResourceAnnotation);
